import midi

nTickUnit = 200
nResol = 240 # default 220

def addSound(track, pitch, len):
  e1 = midi.NoteOnEvent(pitch=pitch, velocity=127)
  e2 = midi.NoteOffEvent(tick = nTickUnit*len, pitch=pitch)
  track.append(e1)
  track.append(e2)

def addPause(track, len):
  e1 = midi.NoteOnEvent(pitch=50, velocity=0)
  e2 = midi.NoteOffEvent(tick = nTickUnit*len, pitch=50)
  track.append(e1)
  track.append(e2)

def addRiff(track, nPitchShift):
  addSound(track, midi.C_3 + nPitchShift, 2)
  addSound(track, midi.E_3 + nPitchShift, 2)
  addSound(track, midi.G_3 + nPitchShift, 1)
  addSound(track, midi.F_3 + nPitchShift, 1)
  addSound(track, midi.D_3 + nPitchShift, 4)

def addAllOctaves(track):
  addRiff(track, 0)
  addRiff(track, 12)
  addRiff(track, 24)
  addRiff(track, 36)
  addPause(track, 8)

t = midi.Track()
for iInstrum in range(128):
  t.append(midi.ProgramChangeEvent(value=iInstrum))
  addAllOctaves(t)
  if iInstrum % 8 == 7:
    t.append(midi.EndOfTrackEvent(tick=1))
    p = midi.Pattern(resolution=nResol)
    p.append(t)
    sFile = "instr_{0:03d}_{1:03d}.mid".format(iInstrum-6, iInstrum+1)
    midi.write_midifile("c:\\temp\\1\\" + sFile, p)
    t = midi.Track()
